/*
 * Author: Jpeng
 *
 * Modified: yeras-is
 */

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';

class LoadMoreWrapper extends StatefulWidget {
  /// widget Column or ListView or other
  final Widget child;
  /// load more function
  final VoidCallback onLoading;

  const LoadMoreWrapper({
    Key key,
    this.child,
    this.onLoading,
  }) : super(key: key);

  @override
  State<StatefulWidget> createState() {
    return _LoadMoreWrapperState();
  }
}

class _LoadMoreWrapperState extends State<LoadMoreWrapper> {
  RefreshController _controller = RefreshController();

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return SmartRefresher(
      child: widget.child,
      controller: _controller,
      onLoading: widget.onLoading,
      enablePullUp: true,
      enablePullDown: false,
    );
  }
}
