/*
 * Author: Jpeng
 *
 * Modified: yeras-is
 */

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';

class RefreshWrapper extends StatefulWidget {
  /// widget Column or ListView or other
  final Widget child;

  /// on Refresh function
  final Function onRefresh;

  const RefreshWrapper({Key key, this.child, this.onRefresh}) : super(key: key);

  @override
  State<StatefulWidget> createState() {
    return _RefreshWrapperState();
  }
}

class _RefreshWrapperState extends State<RefreshWrapper> {
  final RefreshController _refreshController = RefreshController(initialRefresh: false);

  @override
  void dispose() {
    _refreshController.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return SmartRefresher(
      controller: _refreshController,
      child: widget.child,
      physics: BouncingScrollPhysics(),
      onRefresh: () async {
        try {
          await widget.onRefresh.call();
          _refreshController.refreshCompleted();
        } catch (e) {
          _refreshController.refreshFailed();
        }
      },
    );
  }
}
